select
    an.numero as numero,
    an.nome as nome,
    an.nomecompleto as nome_completo,
    an.dtnascimento as data_nascimento,
    an.sexo as sexo,
    (select grausangue from sp_calculagrausangue(an.cdanimal)) as grau_sangue,
    se.nome as setor,
   an.regassocraca as registro,
   cat.nome as categoria,
   (case sp.cprodutiva when 3 then 'Seca' when 4 then 'Lactao' else null end) as sit_produtiva,
   (case sp.creprodutiva when 1 then 'Insem./Cob.' when 2 then 'Implant.' when 3 then 'Gestante' when 4 then 'Vazia' else null end) as sit_reprodutiva,
    pai.numero as numero_pai_13,
    pai.nome as nome_pai_13,
    pai.nomecompleto as nome_completo_pai_13,
    paipai.numero as numero_pai_pai_09,
    paipai.nome as nome_pai_pai_09,
    paipai.nomecompleto as nome_completo_pai_pai_09,
    paipaipai.numero as numero_pai_pai_pai_01,
    paipaipai.nome as nome_pai_pai_pai_01,
    paipaipai.nomecompleto as nome_completo_pai_pai_pai_01,
    maepai.numero as numero_mae_pai_10,
    maepai.nome as nome_mae_pai_10,
    maepai.nomecompleto as nomecompleto_mae_pai_10,
    maepaipai.numero as numero_mae_pai_pai_01,
    maepaipai.nome as nome_mae_pai_pai_02,
    maepaipai.nomecompleto as nome_completo_mae_pai_pai_02,
    paimaepai.numero as numero_pai_mae_pai_03,
    paimaepai.nome as nome_pai_mae_pai_03,
    paimaepai.nomecompleto as nome_completo_pai_mae_pai_03,
    maemaepai.numero as numero_mae_mae_pai_04,
    maemaepai.nome as nome_mae_mae_pai_04,
    maemaepai.nomecompleto as nome_completo_mae_mae_pai_04,
    mae.numero as numero_mae_14,
    mae.nome as nome_mae_14,
    mae.nomecompleto as nome_completo_mae_14,
    paimae.numero as numero_pai_mae_11,
    paimae.nome as nome_pai_mae_11,
    paimae.nomecompleto as nome_completo_pai_mae_11,
    paipaimae.numero as numero_pai_pai_mae_05,
    paipaimae.nome as nome_pai_pai_mae_05,
    paipaimae.nomecompleto as nome_completo_pai_pai_mae_05,
    maepaimae.numero as numero_mae_pai_mae_06,
    maepaimae.nome as nome_mae_pai_mae_06,
    maepaimae.nomecompleto as nome_completomae_pai_mae_06,
    maemae.numero as numero_mae_mae_12,
    maemae.nome as nome_mae_mae_12,
    maemae.nomecompleto as nome_completo_mae_mae_12,
    paimaemae.numero as numero_pai_mae_mae_07,
    paimaemae.nome as nome_pai_mae_mae_07,
    paimaemae.nomecompleto as nome_completo_pai_mae_mae_07,
    maemaemae.numero as numero_mae_mae_mae_08,
    maemaemae.nome as nome_mae_mae_mae_08,
    maemaemae.nomecompleto as nome_completo_mae_mae_mae_08
from
    animal an
    left join setor se on se.cdsetor = an.cdsetor
    left join animal mae on mae.cdanimal = an.cdmae
    left join animal pai on pai.cdanimal = an.cdpai
    left join animal paimae on paimae.cdanimal = mae.cdpai
    left join animal maemae on maemae.cdanimal = mae.cdmae
    left join animal maepaimae on maepaimae.cdanimal = paimae.cdmae
    left join animal paipaimae on paipaimae.cdanimal = paimae.cdpai
    left join animal maemaemae on maemaemae.cdanimal = maemae.cdmae
    left join animal paimaemae on paimaemae.cdanimal = maemae.cdpai
    left join animal paipai on paipai.cdanimal = pai.cdpai
    left join animal maepai on maepai.cdanimal = pai.cdmae
    left join animal paipaipai on paipaipai.cdanimal = paipai.cdpai
    left join animal maepaipai on maepaipai.cdanimal = paipai.cdmae
    left join animal maemaepai on maemaepai.cdanimal = maepai.cdmae
    left join animal paimaepai on paimaepai.cdanimal = maepai.cdpai
    join categoria cat on cat.cdcategoria = an.cdcategoria
    join sp_categoriaanimal(current_date, 'CDANIMAL = ' || an.cdanimal) sp on 1 = 1
where
    an.tipoanimal = 'A' and
    an.animalrebanho = '1' and
    an.dtbaixa is null
